<?php

namespace Shasoft\SamoyedCMG\Generator;

use Twig\TwigFilter;
use Twig\Environment;
use Shasoft\Support\File;
use Shasoft\Support\Composer;
use Shasoft\Support\Values\Get;
use Shasoft\SamoyedCMG\Generator\ManagerGenerators;

// Дополнительные функции
class ApiSavePrivate
{
    // Параметры
    protected Get $args;
    // Конструктор
    public function __construct()
    {
        $this->args = ManagerGenerators::args();
    }
    // Аргументы командной строки
    public function args(): Get
    {
        return $this->args;
    }
    // Получить относительный путь от файла From до файла To
    static public function relative(string $filepathFrom, string $filepathTo): string
    {
        $filepathFrom = self::normalize($filepathFrom);
        $filepathTo = self::normalize($filepathTo);
        $ret = File::relative($filepathFrom, $filepathTo);
        if (substr($ret, 0, 2) == './') {
            $ret = substr($ret, 2);
        }
        //s_dump($filepathFrom, $filepathTo, $ret);
        return $ret;
    }
    /*
    // Нормализовать имя файла относительно сайта
    public function normalize(string $filepath): string
    {
        $rc = Composer::findPackage($filepath);
        if ($rc !== false) {
            // Если это файл не основного пакета
            if ($rc['name'] != $this->args()->get('name')) {
                // То получить ссылку относительно установленных пакетов сайта
                $filepath = $this->composer()->path($rc['name'], $rc['file']);
            }
        }
        return File::normalize($filepath, true);
    }
    //*/
    // Нормализовать имя файла относительно сайта
    static public function normalize(string $filepath): string
    {
        $rc = Composer::findPackage($filepath);
        if ($rc !== false) {
            // Если это не главный пакет сгенерированного сайта
            if ($rc['name'] != ManagerGenerators::args()->get('name')) {
                // Преобразовать файл                
                $filepath = ManagerGenerators::pathSite('vendor/' . $rc['name'] . '/' . $rc['file']);
            }
        }
        return File::normalize($filepath, true);
    }
    // Получить ссылку на файл внутри сайта
    static public function relSite(string $filepath): string
    {
        $ret = ApiSavePrivate::normalize($filepath);
        //
        $ret = substr($ret, strlen(ManagerGenerators::pathSite()) + 1);
        //
        return $ret;
    }
    // Добавить фильтр relScript в Twig
    static public function getTwigFilterRelScript(string $filepathBase): \Closure
    {
        return function (Environment $twig) use ($filepathBase) {
            $twig->addFilter(new TwigFilter(
                'relScript',
                function ($filepath) use ($filepathBase) {
                    return self::relative($filepathBase, $filepath);
                }
            ));
        };
    }
}
