<?php

namespace Shasoft\SamoyedCMG\Generator;

use Shasoft\Support\FriendProxy;
use Shasoft\SamoyedCMG\Generator\ManagerGenerators;
use Shasoft\SamoyedCMG\Generator\Trait\TraitCodeGenerator;

// Домен
class DomainGenerator extends PathGenerator
{
    // Маршруты
    private array $routes = [];
    // Конструктор
    public function __construct(private string $host, int $siteId)
    {
        parent::__construct($siteId, '', null, []);
    }
    // Сайт
    public function site(): SiteGenerator
    {
        return ManagerGenerators::get($this->parentId());
    }
    // Домен
    public function host(): string
    {
        return $this->host;
    }
    // Запустить сохранение
    private function save(): void
    {
        foreach ($this->routes() as $route) {
            (new FriendProxy($route))->save();
        }
    }
}
