<?php

namespace Shasoft\SamoyedCMG\Generator;

use Shasoft\SamoyedCMG\Generator\ApiSave;
use Shasoft\SamoyedCMG\Generator\RouteParse;

// Правило перенаправления для файла .htaccess
class HtaccessRewriteRule extends RouteParse
{
    // Расширение файла
    public string $ext = '';
    // Суффикс строки замены
    public string $substitutionSuffix = '';
    // Аргумены строки замены
    public array $args = [];
    // Флаги
    public string $flags = '';
    // Конструктор
    public function __construct(protected ApiSave $api)
    {
    }
    // Api
    public function api(): ApiSave
    {
        return $this->api;
    }
    // Установить аргумент
    public function setArg(string $name, string $value): void
    {
        // Имя для переменной запроса в файле .htaccess
        $queryName = $this->api()->setArgRoute($name);
        // Установить аргумент правила
        $this->args[$queryName] = $value;
    }
}
