<?php

namespace Shasoft\SamoyedCMG\Generator\Manager;

use Shasoft\Support\File;

// Менеджер генератора сайта (Пути)
trait ManagerGeneratorsPath
{
    // Путь сайта
    static public function pathSite(?string $pathX = null): string
    {
        return File::normalize(self::$singleton->args->get('pathSite') . '/' . self::$singleton->args->get('mode') . (empty($pathX) ? '' : '/' . $pathX), true);
    }
    // Путь до Autoload
    static public function pathAutoload(): string
    {
        return self::pathSite('vendor/autoload.php');
    }
    // Путь до тестов
    static public function pathTests(?string $pathX = null): string
    {
        return self::pathSite('tests') . (empty($pathX) ? '' : '/' . $pathX);
    }
    // Временная директория генерации
    static public function pathTemp(?string $pathX = null): string
    {
        return File::normalize(self::$singleton->args->get('pathSite') . '/~.temp~' . (empty($pathX) ? '' : '/' . $pathX), true);
    }
    // Сохранить состояние
    static public function pathState(string $filename): string
    {
        return self::pathTemp($filename);
    }
    // Путь сайта
    static private function pathSiteSub(?string $pathX = null): string
    {
        $path = (empty(self::$singleton->pathSub) ? '' : self::$singleton->pathSub);
        $path .= (empty($pathX) ? '' : '/' . $pathX);
        return self::pathSite($path);
    }
    // Путь до публичных файлов
    static public function pathServer(?string $pathX = null): string
    {
        return self::pathSiteSub('www-server') . (empty($pathX) ? '' : '/' . $pathX);
    }
    // Путь до скриптов
    static public function pathScripts(?string $pathX = null): string
    {
        return self::pathSiteSub('scripts') . (empty($pathX) ? '' : '/' . $pathX);
    }
}
