<?php

namespace Shasoft\SamoyedCMG\Generator\Manager;

use Shasoft\Support\Php;
use Shasoft\Support\File;

// Менеджер генератора сайта (Скрипты)
trait ManagerGeneratorsScripts
{
    // Скрипты
    private array $scripts = [];
    // Имена файлов скриптов
    private array $files = [];
    // Скрипты
    static public function getScriptId(string $content): int
    {
        //self::$singleton->scripts = [];
        // Определить ХЕШ скрипта
        $hash = 'Z' . self::hash($content);
        if (array_key_exists($hash, self::$singleton->scripts)) {
            return self::$singleton->scripts[$hash]['id'];
        }
        // Создать новый скрипт
        $ret = self::getId();
        // Элементы скрипта
        $types = Php::getClasses($content, Php::C_ALL_FN, true);
        // Имя файла скрипта
        $filepath = self::pathScripts() . '/';
        if (count($types) > 0) {
            foreach ($types as $name => $fn_exists) {
                $filepath .= explode('_', $fn_exists)[0] . '_' . str_replace('\\', '_', $name);
            }
        } else {
            $filepath .= $hash;
        }
        // Имя файла скрипта
        $index = 1;
        $file = $filepath;
        while (array_key_exists($file, self::$singleton->files)) {
            $index++;
            $file = $filepath . $index;
        }
        self::$singleton->files[$file] = 1;
        // Добавить расширение
        $filepath = $file . '.php';
        // Сохранить скрипт
        File::save($filepath, $content);
        // Добавить скрипт
        self::$singleton->scripts[$hash] = [
            'id' => $ret,
            'filepath' => $filepath,
            'types' => $types
        ];
        return $ret;
    }
    // Получить скрипт
    static public function getScript(int $id): ?array
    {
        foreach (self::$singleton->scripts as $hash => $item) {
            if ($item['id'] == $id) {
                return $item;
            }
        }
        return null;
    }
    // Подключить скрипт
    static public function requireScript(int $id): void
    {
        require_once self::getScript($id)['filepath'];
    }
    // Скрипты
    static public function scripts(): array
    {
        return array_values(self::$singleton->scripts);
    }
}
