<?php

namespace Shasoft\SamoyedCMG\Generator;

use Shasoft\SamoyedCMG\Generator\ManagerGenerators;

// Объект генератора
abstract class ObjectGenerator
{
    // Идентификатор
    private int $id = 0;
    // Конструктор
    public function __construct()
    {
        // Идентификатор
        $this->id = ManagerGenerators::getId();
        // Добавить
        ManagerGenerators::add($this);
        // Установить флаг: объект изменил состояние
        ManagerGenerators::setModify($this);
    }
    // Идентификатор
    public function id(): int
    {
        return $this->id;
    }
    // Установить флаг: объект изменил состояние
    protected function setModify(): void
    {
        ManagerGenerators::setModify($this);
    }
    public function __toString(): string
    {
        return get_class($this);
    }
}
