<?php

namespace Shasoft\SamoyedCMG\Generator;

use Shasoft\Support\FriendProxy;
use Shasoft\SamoyedCMG\Generator\DomainGenerator;
use Shasoft\SamoyedCMG\Generator\Trait\TraitCodeGenerator;
use Shasoft\SamoyedCMG\Generator\Trait\TraitPathAndRoute;

// Путь
class PathGenerator extends ObjectSystemGenerator
{
    use TraitCodeGenerator;
    use TraitPathAndRoute;
    // Конструктор
    public function __construct(int $parentId, string $route, ?string $name)
    {
        parent::__construct($parentId);
        // Маршрут
        $this->route = $route;
        // Имя
        $this->name = $name;
    }
    // Добавить путь
    public function addPath(string $route, ?string $name, \Closure $cb): static
    {
        // Если имя указано
        if (!empty($name)) {
            // то проверить его на соответствие
            // ...
        }
        // Создать
        $pathMakwer = new PathGenerator($this->id(), $route, $name);
        // Добавить в дочерние
        $this->childs[] = $pathMakwer->id();
        // Настроить
        $cb($pathMakwer);
        // Установить флаг изменений
        $this->setModify();
        // Вернуть указатель на себя
        return $this;
    }
    // Добавить маршрут
    public function addRoute(RouteGenerator $route, ?\Closure $cb = null): static
    {
        // Добавить в дочерние
        $this->childs[] = $route->id();
        // Прокси объект для доступа к маршруту
        $routeProxy = new FriendProxy($route);
        // Родительский элемент
        $routeProxy->parentId = $this->id();
        /*
        // Прокси объект для доступа к объекту
        $domainProxy = new FriendProxy($this->domain());
        // Список маршрутов домена
        $routes = $domainProxy->routes;
        // Маршрут
        $routeUrl = $route->route();
        // А может такой маршрут уже есть?
        if (array_key_exists($routeUrl, $routes)) {
            throw new \Exception('Домен ' . $this->domain()->host() . ' уже содержит маршрут ' . $routeUrl . '!');
        }
        // Добавить в список маршрутов домена
        $routes[$routeUrl] = $route->id();
        $domainProxy->routes = $routes;
        //*/
        // Вызвать функцию настройки
        if (!is_null($cb)) {
            $cb($route);
        }
        // Вернуть указатель на себя
        return $this;
    }
}
