<?php

namespace Shasoft\SamoyedCMG\Generator\Service;

use Shasoft\SamoyedCMG\Generator\ApiHtml;
use Shasoft\SamoyedCMG\Service\IPath;
use Shasoft\SamoyedCMG\Generator\ApiGenerate;
use Shasoft\SamoyedCMG\Generator\ServiceCodeGenerator;

// Генератор сервиса работы с путями 
class ServiceGeneratorPath extends ServiceCodeGenerator
{
    // Конструктор
    public function __construct(protected string $dataKey)
    {
        parent::__construct();
    }
    // Генерация
    protected function onGenerate(ApiGenerate $api): void
    {
        // Имя класса
        $classname = str_replace('IPath', 'Path', IPath::class);
        // Генератор добавлен для узла Сайт?
        if ($api->hasType('site')) {
            $host = null;
        } else {
            $host = $api->parentObject()->domain()->host();
        }
        // Установить класс в качестве сервиса и если произошло изменение сервисов
        if ($api->setService(IPath::class, $classname)) {
            // То сгенерировать класс по шаблону
            $api->addScript(__DIR__ . '/../../../twig/Service/Path.php.twig', [
                'host' => $host,
                'classname' => $classname,
                'dataKey' => $this->dataKey
            ]);
        }
    }
    // Получить HTML код с информацией о генераторе
    protected function getHtml(ApiHtml $api): string
    {
        return "<strong>dataKey</strong>: " . $this->dataKey;
    }
}
