<?php

namespace Shasoft\SamoyedCMG\Service;

use Shasoft\SamoyedCMG\Service\IService;
use Symfony\Component\HttpFoundation\FileBag;
use Symfony\Component\HttpFoundation\InputBag;
use Symfony\Component\HttpFoundation\HeaderBag;
use Symfony\Component\HttpFoundation\ServerBag;

// Сервис запроса
interface IRequest extends IService
{
    // Это AJAX запрос?
    public function isAjax(): bool;
    // Получить ссылку запроса
    public function url(): string;
    // Метод
    public function method(): string;
    // Request body parameters ($_POST).
    public function post(): InputBag;
    // Query string parameters ($_GET).
    public function query(): InputBag;
    // Server and execution environment parameters ($_SERVER).
    public function server(): ServerBag;
    // Uploaded files ($_FILES).
    public function files(): FileBag;
    // Cookies ($_COOKIE).
    public function cookies(): InputBag;
    // Headers (taken from the $_SERVER).
    public function headers(): HeaderBag;
}
