<?php

namespace Shasoft\SamoyedCMG\Service;

use Symfony\Component\HttpFoundation\FileBag;
use Symfony\Component\HttpFoundation\InputBag;
use Symfony\Component\HttpFoundation\HeaderBag;
use Symfony\Component\HttpFoundation\ServerBag;
use Symfony\Component\HttpFoundation\Request as SymfonyRequest;

class Request implements IRequest
{
    // Запрос
    protected SymfonyRequest $symfonyRequest;
    // Конструктор
    public function __construct()
    {
        $this->symfonyRequest = SymfonyRequest::createFromGlobals();
    }
    // Запрос
    // https://symfony.com/doc/current/components/http_foundation.html
    public function getSymfonyRequest(): SymfonyRequest
    {
        return $this->symfonyRequest;
    }
    // Это AJAX запрос?
    public function isAjax(): bool
    {
        return $this->symfonyRequest->isXmlHttpRequest();
    }
    // Получить адрес запроса
    public function url(): string
    {
        return $this->symfonyRequest->getPathInfo();
    }
    // Метод
    public function method(): string
    {
        return $this->symfonyRequest->getMethod();
    }
    // Request body parameters ($_POST).
    public function post(): InputBag
    {
        return $this->symfonyRequest->request;
    }
    // Query string parameters ($_GET).
    public function query(): InputBag
    {
        return $this->symfonyRequest->query;
    }
    // Server and execution environment parameters ($_SERVER).
    public function server(): ServerBag
    {
        return $this->symfonyRequest->server;
    }
    // Uploaded files ($_FILES).
    public function files(): FileBag
    {
        return $this->symfonyRequest->files;
    }
    // Cookies ($_COOKIE).
    public function cookies(): InputBag
    {
        return $this->symfonyRequest->cookies;
    }
    // Headers (taken from the $_SERVER).
    public function headers(): HeaderBag
    {
        return $this->symfonyRequest->headers;
    }
}
