<?php

namespace Shasoft\SamoyedCMG\Test\Assert;

use Shasoft\SamoyedCMG\Test\TestException;


// Класс для запуска теста
trait AssertMain
{
    // Проверить равенство
    protected function assertEquals(mixed $value1, mixed $value2): void
    {
        if ($value1 != $value2) {
            throw new TestException('$value1!=$value2', function () use ($value1, $value2) {
                s_dump($value1, $value2);
            });
        }
    }
    // Проверить НЕ равенство
    protected function assertNotEquals(mixed $value1, mixed $value2): void
    {
        if ($value1 == $value2) {
            throw new TestException('$value1==$value2', function () use ($value1, $value2) {
                s_dump($value1, $value2);
            });
        }
    }
    // Проверить значение ИСТИНИ
    protected function assertTrue(bool $value): void
    {
        if ($value != true) {
            throw new TestException('$value!=TRUE', function () use ($value) {
                s_dump($value);
            });
        }
    }
    // Проверить значение ЛОЖЬ
    protected function assertFalse(bool $value): void
    {
        if ($value != false) {
            throw new TestException('$value!=FALSE', function () use ($value) {
                s_dump($value);
            });
        }
    }
}
