<?php

namespace Shasoft\SamoyedCMG\Test\Assert;

use Shasoft\SamoyedCMG\Test\TestException;
use Shasoft\SamoyedCMG\DebugProxyService;


// Проверки лога вызовов сервисов
trait AssertService
{
    // Получить вызовы сервисов
    protected function getServiceCall(?string $serviceName = null, ?string $name = null): array
    {
        return DebugProxyService::get($serviceName, $name);
    }
    // Проверить равенство
    protected function assertServiceCall(int $cnt, ?string $serviceName = null, ?string $name = null): void
    {
        $calls = $this->getServiceCall($serviceName, $name);
        if (count($calls) != $cnt) {
            throw new TestException('countServicesCall()!=' . $cnt, function () use ($calls) {
                s_dump($calls);
            });
        }
    }
}
