<?php

namespace Shasoft\Support;

class Arr extends \Illuminate\Support\Arr
{
    // Установить значение если такого ключа ещё нет
    public static function setIf(&$array, $key, $value)
    {
        $ret = false;
        if (!self::has($array, $key)) {
            self::set($array, $key, $value);
            $ret = true;
        }
        return $ret;
    }
    // Преобразовать значение в массив значений (если это уже не массив)
    public static function remove(&$array, $key)
    {
        self::forget($array, $key);
    }

    // Получить значение. Если оно пустое, то взять значение по умолчанию
    public static function getEmpty($array, $key, $value)
    {
        $ret = self::get($array, $key);
        if (empty($ret)) {
            $ret = $value;
        }
        return $ret;
    }
    // Групировка массива по полю
    public static function groupBy(array $data, $fieldname)
    {
        $ret = [];
        //
        foreach ($data as $item) {
            $column = $item[$fieldname];
            unset($item[$fieldname]);
            if (isset($ret[$column])) {
                $ret[$column][] = $item;
            } else {
                $ret[$column] = array($item);
            }
        }
        //
        return $ret;
    }
    // Преобразовать значение в массив значений (если это уже не массив)
    public static function toArr($value)
    {
        if (!is_array($value)) {
            return [$value];
        }
        return $value;
    }
}
