<?php

namespace Shasoft\Support;

// Серилизация данных
// 
class Serialize
{
    // Серилизовать данные
    public static function toStr(mixed $data, string $format, ?int $options = null): string
    {
        $ret = $data;
        // Преобразовать к нижнему регистру
        $format = strtolower($format);
        // Трансформировать данные в зависимости от формата
        if ($format == 'json') {
            if (is_null($options)) {
                // https://stackoverflow.com/questions/46305169/php-json-encode-malformed-utf-8-characters-possibly-incorrectly-encoded
                // Malformed UTF-8 characters, possibly incorrectly encoded => JSON_INVALID_UTF8_SUBSTITUTE
                $options = JSON_PRETTY_PRINT | JSON_UNESCAPED_SLASHES | JSON_INVALID_UTF8_SUBSTITUTE; //JSON_INVALID_UTF8_IGNORE;
            }
            /*
            // Symfony\Polyfill\Intl\Normalizer\Normalizer
            foreach ($data as $classname => $classInfo) {
            echo $classname . "\t" . $classInfo['filename'] . "\n";
            $data = json_encode($classInfo, $options);
            if ($data === false) {
            exit(1);
            }
            }
            //*/
            $ret = json_encode($data, $options);
            if ($ret === false) {
                echo "json_encode()\n\t" . json_last_error_msg() . "\n";
                exit(1);
            }
            //s_dd("-", $data, $options);
        } else if ($format == 'dat') {
            //$ret = Serialize::toStr($data);
            throw new \Exception('Нет реализации!');
        } else if ($format == 'phpdat' || $format == 'ser') {
            $ret = \serialize($data);
        } else if ($format == 'php') {
            $phpMarker = '<?php';
            if (substr($data, 0, strlen($phpMarker)) != $phpMarker) {
                $ret = $phpMarker . "\n" . $data;
            }
        }
        return $ret;
    }
    // ДеСерилизовать данные
    public static function fromStr(string $str, string $format): mixed
    {
        $ret = $str;
        // Трансформировать данные в зависимости от формата
        if ($format == 'json') {
            $ret = json_decode($str, true, 512);
            if (json_last_error() != JSON_ERROR_NONE) {
                throw new \Exception('Parse json data');
            }
        } else if ($format == 'dat') {
            //$ret = Serialize::fromStr($str);
            throw new \Exception('Нет реализации!');
        } else if ($format == 'phpdat' || $format == 'ser') {
            $ret = \unserialize($str);
        }
        return $ret;
    }
}
