<?php

namespace Shasoft\Support\Values;

use Shasoft\Support\Arr;

// Часть значение
trait ChunckGetTrait
{
    // Получить значение
    public function get(string $key, mixed $default = null): mixed
    {
        $key = $this->_key($key);
        return Arr::get($this->ref_values->data, $key, $default);
    }
    // Проверить наличие значения
    public function has(string $key): bool
    {
        $key = $this->_key($key);
        return Arr::has($this->ref_values->data, $key);
    }
    // Все настройки
    public function all(): array
    {
        if (is_null($this->key)) {
            return $this->ref_values->data;
        }
        return Arr::get($this->ref_values->data, $this->key, []);
    }
    // Получить часть значений
    public function path(string $key): Get
    {
        $key = $this->_key($key);
        return new Get($this->get($key, []));
    }
}
