<?php

namespace Shasoft\Support\Values;

use Shasoft\Support\Arr;

// Часть значение
trait ChunckSetTrait
{
    // Установить значение
    public function set(string $key, mixed $value, bool $dotNotation = true): static
    {
        $key = $this->_key($key);
        //s_dd($this->ref_values);
        Arr::set($this->ref_values->data, $key, $value);
        // Вернуть указатель на себя
        return $this;
    }
    // Установить значение
    public function setX(string $key, mixed $value): static
    {
        //
        if (is_null($this->key)) {
            $this->ref_values->data[$key] = $value;
        } else {
            $vals = Arr::get($this->ref_values->data, $this->key, []);
            $vals[$key] = $value;
            Arr::set($this->ref_values->data, $this->key, $vals);
        }
        // Вернуть указатель на себя
        return $this;
    }
    // Установить значение параметра ЕСЛИ
    public function setIf(bool $isDefined, string $key, mixed $value): static
    {
        $key = $this->_key($key);
        // Установить значение (если оно ЕСТЬ/НЕТ)
        if (Arr::has($this->ref_values->data, $key) == $isDefined) {
            Arr::set($this->ref_values->data, $key, $value);
        }
        // Вернуть указатель на себя
        return $this;
    }
    // Добавить значение в конец
    public function push(string $key, mixed $value): static
    {
        $key = $this->_key($key);
        // Получить значениЯ
        $vals = Arr::get($this->ref_values->data, $key, []);
        // Добавить значениt
        $vals[] = $value;
        // Установить новые значениЯ
        Arr::set($this->ref_values->data, $key, $vals);
        // Вернуть указатель на себя
        return $this;
    }
    // Добавить значение в начало
    public function unshift(string $key, mixed $value): static
    {
        $key = $this->_key($key);
        // Получить значениЯ
        $vals = Arr::get($this->ref_values->data, $key, []);
        // Добавить значение в начало
        array_unshift($vals, $value);
        // Установить новые значениЯ
        Arr::set($this->ref_values->data, $key, $vals);
        // Вернуть указатель на себя
        return $this;
    }
    // Добавить/заменить значение
    function pushX(string $key, string $value, string $delimeter): static
    {
        // Это имя от корня?
        if (substr($value, 0, 1) == $delimeter) {
            // Заменить текущие значения
            $vals = explode($delimeter, substr($value, 1));
        } else {
            // Добавить новое значение
            $vals = $this->get($key, []);
            $vals = array_merge($vals, explode($delimeter, $value));
        }
        // Установить новые значениЯ
        $key = $this->_key($key);
        Arr::set($this->ref_values->data, $key, $vals);
        // Вернуть указатель на себя
        return $this;
    }
    // Удалить значение
    public function remove(string $key): static
    {
        $key = $this->_key($key);
        Arr::remove($this->ref_values->data, $key);
        // Вернуть указатель на себя
        return $this;
    }
    // Получить кусок
    public function chunck(string $key, $cb = null, $data = null): static
    {
        $key = $this->_key($key);
        $ret = new Chunck($this->ref_values, $key);
        if (is_null($cb)) {
            return $ret;
        } else {
            $cb($ret, $data);
        }
        // Вернуть указатель на себя
        return $this;
    }
}
