<?php

namespace Shasoft\Support\Values;

use Shasoft\Support\Arr;

// Значения
class Set extends Get
{
    use ChunckSetTrait;
    // Конструктор
    public function __construct($data = [])
    {
        parent::__construct($data);
        // Проставить ссылку на данные
        $this->ref_values = $this->values;
    }
    // Получить/установить часть значений
    public function path(string $key, ?callable $cb = null): static
    {
        $key = $this->_key($key);
        if (is_null($cb)) {
            return parent::path($key);
        } else {
            // Создать объект
            $values = new Set($this->get($key, []));
            // Вызвать функцию обратного 
            $cb($values);
            // Установить значения
            Arr::set($this->ref_values->data, $key, $values->ref_values->data);
        }
        // Вернуть указатель на себя
        return $this;
    }
}
